program lightning;

(* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version 
 * 1.1 (the "License"); you may not use this file except in compliance with 
 * the License. You may obtain a copy of the License at 
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Lightning application.
 *
 * The Initial Developer of the Original Code is
 * Tomsoft.
 * Portions created by Tomsoft are Copyright (C) 2009
 * Tomsoft. All Rights Reserved.
 *
 * Contributor(s):
 *   Tommy Sools <tom@sools.com>
 *
 * ***** END LICENSE BLOCK ***** *)

{$A8,B-,C-,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y-,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
{$WARN SYMBOL_DEPRECATED ON}
{$WARN SYMBOL_LIBRARY ON}
{$WARN SYMBOL_PLATFORM OFF}
{$WARN UNIT_LIBRARY ON}
{$WARN UNIT_PLATFORM ON}
{$WARN UNIT_DEPRECATED ON}
{$WARN HRESULT_COMPAT ON}
{$WARN HIDING_MEMBER ON}
{$WARN HIDDEN_VIRTUAL ON}
{$WARN GARBAGE ON}
{$WARN BOUNDS_ERROR ON}
{$WARN ZERO_NIL_COMPAT ON}
{$WARN STRING_CONST_TRUNCED ON}
{$WARN FOR_LOOP_VAR_VARPAR ON}
{$WARN TYPED_CONST_VARPAR ON}
{$WARN ASG_TO_TYPED_CONST ON}
{$WARN CASE_LABEL_RANGE ON}
{$WARN FOR_VARIABLE ON}
{$WARN CONSTRUCTING_ABSTRACT ON}
{$WARN COMPARISON_FALSE ON}
{$WARN COMPARISON_TRUE ON}
{$WARN COMPARING_SIGNED_UNSIGNED ON}
{$WARN COMBINING_SIGNED_UNSIGNED ON}
{$WARN UNSUPPORTED_CONSTRUCT ON}
{$WARN FILE_OPEN ON}
{$WARN FILE_OPEN_UNITSRC ON}
{$WARN BAD_GLOBAL_SYMBOL ON}
{$WARN DUPLICATE_CTOR_DTOR ON}
{$WARN INVALID_DIRECTIVE ON}
{$WARN PACKAGE_NO_LINK ON}
{$WARN PACKAGED_THREADVAR ON}
{$WARN IMPLICIT_IMPORT ON}
{$WARN HPPEMIT_IGNORED ON}
{$WARN NO_RETVAL ON}
{$WARN USE_BEFORE_DEF ON}
{$WARN FOR_LOOP_VAR_UNDEF ON}
{$WARN UNIT_NAME_MISMATCH ON}
{$WARN NO_CFG_FILE_FOUND ON}
{$WARN MESSAGE_DIRECTIVE ON}
{$WARN IMPLICIT_VARIANTS ON}
{$WARN UNICODE_TO_LOCALE ON}
{$WARN LOCALE_TO_UNICODE ON}
{$WARN IMAGEBASE_MULTIPLE ON}
{$WARN SUSPICIOUS_TYPECAST ON}
{$WARN PRIVATE_PROPACCESSOR ON}
{$WARN UNSAFE_TYPE OFF}
{$WARN UNSAFE_CODE OFF}
{$WARN UNSAFE_CAST OFF}

uses
  Windows,
  Forms,
  SysUtils,
  Controls,
  unitformlightning in 'unitformlightning.pas' {formLightning},
  unitformdetails in 'unitformdetails.pas' {formDetails},
  common in '..\common.pas',
  unitformabout in 'unitformabout.pas' {formAbout},
  unitthreadtimer in 'unitthreadtimer.pas',
  unitformscenemanager in 'unitformscenemanager.pas' {formSceneManager},
  unitformprogrammanager in 'unitformprogrammanager.pas' {formProgramManager},
  unitmodulecomponent in 'unitmodulecomponent.pas',
  unitmodulelua in 'unitmodulelua.pas',
  unitmoduledlop in 'unitmoduledlop.pas',
  unitformsceneproperties in 'unitformsceneproperties.pas' {formSceneProperties},
  unitformconfiguration in 'unitformconfiguration.pas' {formConfiguration},
  unitmodule in 'unitmodule.pas',
  unitformpastearray in 'unitformpastearray.pas' {formPasteArray},
  unitmodulecomponentin in 'unitmodulecomponentin.pas',
  unitmodulecomponentout in 'unitmodulecomponentout.pas',
  unitdesktopview in 'unitdesktopview.pas',
  unitformdlop in 'unitformdlop.pas' {formDLOP},
  unitformsplash in 'unitformsplash.pas' {formSplash},
  unitframeaboutlua in 'unitframeaboutlua.pas' {frameAboutLUA: TFrame},
  unitframeaboutbasslibrary in 'unitframeaboutbasslibrary.pas' {frameAboutBASSLibrary: TFrame},
  unitframeaboutwsockets in 'unitframeaboutwsockets.pas' {frameAboutWSockets: TFrame},
  unitframeaboutxdom in 'unitframeaboutxdom.pas' {frameAboutXdom: TFrame},
  unitlightningsettings in 'unitlightningsettings.pas',
  unitformtrace in 'unitformtrace.pas' {formTrace},
  unitconnector in 'unitconnector.pas',
  Xdom_3_2 in '..\components\Xdom_3_2\Xdom_3_2.pas',
  cUnicodeCodecs in '..\components\Utilities\cUnicodeCodecs.pas',
  ParserUtils in '..\components\Utilities\ParserUtils.pas',
  UnicodeUtils in '..\components\Utilities\UnicodeUtils.pas',
  WideStringUtils in '..\components\Utilities\WideStringUtils.pas',
  TreeUtils in '..\components\Utilities\TreeUtils.pas',
  MiscUtils in '..\components\Utilities\MiscUtils.pas',
  LangUtils in '..\components\Utilities\LangUtils.pas',
  AbnfUtils in '..\components\Utilities\AbnfUtils.pas',
  UriUtils in '..\components\Utilities\UriUtils.pas',
  XmlRulesUtils in '..\components\Utilities\XmlRulesUtils.pas',
  usmallport in '..\components\usmallport.pas',
  dlua in '..\components\lua\dlua.pas',
  VistaAltFixUnit in '..\components\VistaAltFixUnit.pas',
  unitframeaboutcopyright in 'unitframeaboutcopyright.pas' {frameAboutCopyright: TFrame},
  unitframeaboutbeta in 'unitframeaboutbeta.pas' {frameAboutBeta: TFrame};

{$R *.RES}
{$R ..\RESOURCES\MANIFEST.RES}

begin
  lightningSettings := TLightningSettings.Create();
  try
  try
  if lightningSettings.splash then
  begin
    formSplash := TformSplash.Create(nil);
    formSplash.Show();
    formSplash.Repaint();
  end;
  Application.Title := 'Lightning';
  Application.Initialize();
  Application.CreateForm(TformLightning, formLightning);
  Application.CreateForm(TformAbout, formAbout);
  Application.CreateForm(TformProgramManager, formProgramManager);
  Application.CreateForm(TformSceneManager, formSceneManager);
  Application.CreateForm(TformConfiguration, formConfiguration);
  Application.CreateForm(TformPasteArray, formPasteArray);
  Application.CreateForm(TformDLOP, formDLOP);
  finally
    if formSplash <> nil then
      formSplash.Free();
  end;
  formLightning.welcome();
  Application.Run();
  finally
    lightningSettings.Free();
  end;
end.
