unit unitformdetails;

(* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version 
 * 1.1 (the "License"); you may not use this file except in compliance with 
 * the License. You may obtain a copy of the License at 
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Lightning details window.
 *
 * The Initial Developer of the Original Code is
 * Tomsoft.
 * Portions created by Tomsoft are Copyright (C) 2009
 * Tomsoft. All Rights Reserved.
 *
 * Contributor(s):
 *   Tommy Sools <tom@sools.com>
 *
 * ***** END LICENSE BLOCK ***** *)

interface

uses
  Forms, Classes, Controls, StdCtrls, unitmodule, Buttons, ExtCtrls;

type
  TformDetails = class(TForm)
    panelPin: TPanel;
    speedButtonPin: TSpeedButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure speedButtonPinClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure speedButtonUpdate();
  public
    { Public declarations }
    module: TModule;
  end;

implementation

{$R *.dfm}
{$R ..\RESOURCES\PIN.RES}

uses
  unitformlightning;

procedure TformDetails.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  module.closeDetails(False);
  Action := caFree;
end;

procedure TformDetails.FormCreate(Sender: TObject);
begin
  module := nil;
end;

procedure TformDetails.FormDestroy(Sender: TObject);
begin
  module.hide(module.module);
end;

procedure TformDetails.speedButtonUpdate();
begin
  if speedButtonPin.Tag > 0 then
    speedButtonPin.Glyph.LoadFromResourceName(hInstance, 'pindown')
  else
    speedButtonPin.Glyph.LoadFromResourceName(hInstance, 'pinup');
end;

procedure TformDetails.speedButtonPinClick(Sender: TObject);
begin
  speedButtonPin.BringToFront();
  if speedButtonPin.Tag > 0 then
    speedButtonPin.Tag := 0
  else
    speedButtonPin.Tag := 1;
  speedButtonUpdate();
end;

procedure TformDetails.FormShow(Sender: TObject);
begin
  speedButtonUpdate();
end;

end.
